module Hermes
  module RexClient
    class UpdateStructureTask

      def execute(client = Hermes::RexClient::Client.new, rex_entity, className)
        structure = className.constantize.find_by(siret: rex_entity[:siret])
        structure = className.constantize.create() if !structure

        structure.title = rex_entity[:app_comm]
        structure.id_rex = rex_entity[:id]
        structure.cristal_id = rex_entity[:id_cristal]

        if rex_entity[:id_parent_rex]
          parent = className.constantize.find_by({id_rex: rex_entity[:id_parent_rex]})
          createParent(structure, className, rex_entity[:id_parent_rex]) if !parent
          structure.id_parent = parent.id
        end

        structure.save
      end

      def createParent(structure, className, id_parent_rex)
        rex_parent = client.find_structure_by_id(id_parent_rex)
        parent = className.constantize.create({
          title: rex_entity[:app_comm],
          id_rex: rex_entity[:id],
          cristal_id: rex_entity[:id_cristal]
        })

        if rex_parent[:id_parent_rex]
          parent = className.constantize.find_by({id_rex: rex_parent[:id_parent_rex]})
          createParent(structure, className, rex_parent[:id_parent_rex]) if !parent
          parent.id_parent = parent.id
          parent.save
        end
      end
    end
  end
end
